SystemOrganization addCategory: #'Equipement-TIT'!

Object subclass: #PLCInput
	instanceVariableNames: 'vallabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

PLCInput subclass: #AnalogInput
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

AnalogInput class
	instanceVariableNames: 'val aSmallInteger'!

AnalogInput class
	instanceVariableNames: 'val aSmallInteger'!

!AnalogInput methodsFor: 'accessing' stamp: ''!
pointValue
	^ 32767
		min: (0
				max: (val
						ifNil: [0]))! !

!AnalogInput methodsFor: 'accessing' stamp: ''!
pointValue: aSmallInteger 
	val := aSmallInteger! !

PLCInput subclass: #DigitalInput
	instanceVariableNames: 'state etat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!DigitalInput methodsFor: 'accessing' stamp: ''!
etatGen
	^ etat! !

!DigitalInput methodsFor: 'accessing' stamp: ''!
stateOff
	etat := false! !

!DigitalInput methodsFor: 'accessing' stamp: ''!
stateOn
	etat := true! !

!PLCInput methodsFor: 'accessing' stamp: ''!
label
	^ vallabel! !

!PLCInput methodsFor: 'accessing' stamp: ''!
label: aByteString 
	vallabel := aByteString! !

Object subclass: #RFGENERATOR
	instanceVariableNames: 'inpwron inrfon val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!RFGENERATOR methodsFor: 'accessing' stamp: ''!
currentPower
	^ val * 0.153! !

!RFGENERATOR methodsFor: 'accessing' stamp: ''!
inputCurrentPower: anAnalogInput 
	val = anAnalogInput! !

!RFGENERATOR methodsFor: 'accessing' stamp: ''!
inputPwron: aDigitalInput 
	inpwron := aDigitalInput! !

!RFGENERATOR methodsFor: 'accessing' stamp: ''!
inputputRfon: aDigitalInput 
	inrfon := aDigitalInput! !

!RFGENERATOR methodsFor: 'accessing' stamp: ''!
isRunning
	^ inpwron etatGen
		and: [inrfon etatGen]! !

TestCase subclass: #AnalogInputTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: ''!
test15000ResultShouldBe15000
	| power |
	power := AnalogInput new.
	power pointValue: 15000.
	self assert: 15000 = power pointValue! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: ''!
testDefautResultShouldBe0
	| power |
	power := AnalogInput new.
	power label: 'QPW1'.
	self assert: 0 = power pointValue! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: ''!
testDefautResultShouldBeQPW1
	| power |
	power := AnalogInput new.
	power label: 'QPW1'.
	self assert: 'QPW1' = power label! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: ''!
testMaximumResultShouldBe32767
	| power |
	power := AnalogInput new.
	power pointValue: 40000.
	self assert: 32767 = power pointValue! !

!AnalogInputTest methodsFor: 'as yet unclassified' stamp: ''!
testNegatifResultShouldBe15000
	| power |
	power := AnalogInput new.
	power pointValue: -1.
	self assert: 0 = power pointValue! !

TestCase subclass: #CurrentPowerTest
	instanceVariableNames: 'pwrOn rfOn inputPower myGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!CurrentPowerTest methodsFor: 'as yet unclassified' stamp: ''!
setUp
	pwrOn := DigitalInput new label: 'PWRON'.
	rfOn := DigitalInput new label: 'RFON'.
	inputPower := AnalogInput new label: 'QPW1'.
	myGenerator := RFGENERATOR new.
	myGenerator inputPwron: pwrOn;
		 inputputRfon: rfOn;
		 inputCurrentPower: inputPower! !

!CurrentPowerTest methodsFor: 'as yet unclassified' stamp: ''!
test2cas
	inputPower pointValue: 35767.
	self assert: myGenerator currentPower = 5000! !

!CurrentPowerTest methodsFor: 'as yet unclassified' stamp: ''!
test3cas
	inputPower pointValue: 1000.
	self assert: myGenerator currentPower = 153! !

!CurrentPowerTest methodsFor: 'as yet unclassified' stamp: ''!
testPremiercas
	inputPower pointValue: 0.
	self assert: myGenerator currentPower = 0! !

TestCase subclass: #RFGeneratorTest
	instanceVariableNames: 'pwron rfon myGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Equipement-TIT'!

!RFGeneratorTest methodsFor: 'as yet unclassified' stamp: ''!
setUp
	pwron := DigitalInput new.
	pwron label: 'PWRON'.
	rfon := DigitalInput new.
	rfon label: 'RFON'.
	myGenerator := RFGENERATOR new.
	myGenerator inputPwron: pwron;
		 inputputRfon: rfon! !

!RFGeneratorTest methodsFor: 'as yet unclassified' stamp: ''!
testDeuxEntreesFalse
	pwron stateOff.
	rfon stateOff.
	self deny: myGenerator isRunning! !

!RFGeneratorTest methodsFor: 'as yet unclassified' stamp: ''!
testDeuxcas
	pwron stateOn.
	rfon stateOff.
	self deny: myGenerator isRunning! !

!RFGeneratorTest methodsFor: 'as yet unclassified' stamp: ''!
testTroisCas
	pwron stateOff.
	rfon stateOn.
	self deny: myGenerator isRunning! !

!RFGeneratorTest methodsFor: 'as yet unclassified' stamp: ''!
testquatrecas
	pwron stateOn.
	rfon stateOn.
	self assert: myGenerator isRunning! !
